﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Collections.ObjectModel;

namespace CustomDebugger
{
    /// <summary>
    /// 实现仅做示例
    /// </summary>
    [DebuggerVisualizer(typeof(MyTableDebuggerVisualizer))]
    [Serializable]
    public class MyTable
    {
        public MyTable()
        {
            this.Columns = new MyColumnCollection();
            this.Rows = new MyRowCollection();
        }

        public MyColumnCollection Columns { get; private set; }
        public MyRowCollection Rows { get; private set; }
    }

    [Serializable]
    public class MyColumn
    {
        public string Name { get; set; }
    }

    [Serializable]
    public class MyColumnCollection : KeyedCollection<string, MyColumn>
    {
        protected override string GetKeyForItem(MyColumn item)
        {
            return item.Name;
        }
    }

    [Serializable]
    public class MyRow
    {
        public MyRow()
        {
            this.Datas = new List<string>();
        }

        public List<string> Datas { get; private set; }
    }

    [Serializable]
    public class MyRowCollection : Collection<MyRow>
    {
        public void Add(params string[] datas)
        {
            var row = new MyRow();
            row.Datas.AddRange(datas);
            this.Add(row);
        }
    }
}
